#include "bas_inc.hh"

#define B_RESTORE(unsigned n) DATA_PTR=n

#define B_READ(target) \
    if(unlikely(DATA_PTR >= DATA_COUNT)) { ERROR(4); } /*OUT OF DATA*/ \
    else B_READ_DO(target, DATA_TABLE[DATA_PTR++]);

inline void B_READ_DO(BAS_STR& target, const char* input)
    { target=input; }
inline void B_READ_DO(BAS_LNG& target, const char* input)
    { BAS_DBL tmp; B_READ_DO(tmp,input); target=BasCLNG(tmp); }
inline void B_READ_DO(BAS_INT& target, const char* input);
    { BAS_DBL tmp; B_READ_DO(tmp,input); target=BasCINT(tmp); }
inline void B_READ_DO(BAS_SGN& target, const char* input)
    { BAS_DBL tmp; B_READ_DO(tmp,input); target=tmp; }
void B_READ_DO(BAS_DBL& target, const char* input);
