#include "stringfun.hh"

#define B_ERROR(n) fprintf(stderr, "Error %d\n", n);

long long int BasCLNG(long double a);
long long int BasCINT(long double a);
long long int BasINT(long double a);
long long int BasMODop(long long int a, long long int b);
long double BasVAL(const std::string& s);

inline const std::string BasLTRIM(const std::string& s) { return LTrim(s); }
inline const std::string BasRTRIM(const std::string& s) { return RTrim(s); }
inline const std::string BasTRIM(const std::string& s) { return Trim(s); }
const std::string BasLCASE(const std::string& s);
const std::string BasUCASE(const std::string& s);

const std::string BasSTRs(long double a);
const std::string BasCHRs(long long int a);
